=== debian/changelog ===
mbedtls (2.28.3-1) unstable; urgency=medium

  * New upstream version 2.28.3
    We are now in the bookworm hard freeze, but I still think that releasing
    this now is sensible. Importing new upstream LTS releases is the only way
    of properly backporting mbedtls' security fixes, so this release should be
    ported to bookworm, sooner or later.
  * d/{control,rules}: honour nocheck and nodoc profiles

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 29 Mar 2023 21:39:41 +0200
