=== debian/tests/control ===
Tests: build, selftest
Depends: @, gcc, libc6-dev | libc-dev
